module Types
  ( Plan
  , PlanHint
  , Skill
  , Character(..)
  , SkillPattern
  , PanelKind(..)
  , showKind
  , SkillTarget(..)
  , nFreeSkill
  , autoCureProbDenom
  , autoCureProbNum
  , CharDescr(..)
  , skName
  ) where

import {-# SOURCE #-} Plan(Plan, PlanHint)
import {-# SOURCE #-} Game(Skill, skName)

data Character
  = Ch
  { chName :: !(Maybe String)
  , chVit :: !Int
  , chReflex :: !Int
  , chInt :: !Int
  , chSkillPats :: ![SkillPattern]
  , chSkillPatNames :: ![String]
  , chSkills :: ![Skill]
  , chPlans :: ![Plan]
  , chPlanHints :: ![PlanHint]
  }
  deriving (Show, Eq)

type SkillPattern = [PanelKind]
data PanelKind = Fire | Water | Wind | Earth | Sword
  deriving (Show, Eq, Enum, Bounded, Ord)

showKind :: PanelKind -> String
showKind Earth = "地"
showKind Fire = "火"
showKind Water = "水"
showKind Wind = "風"
showKind Sword = "剣"

data SkillTarget
  = PanelTarget !CharDescr !Int !Int
  | SkillTarget !CharDescr !Int
  | PlanTarget !CharDescr !Int
  deriving (Show, Eq, Ord)

data CharDescr = First | Second
  deriving (Show, Eq, Ord)

nFreeSkill :: Int
nFreeSkill = 2

autoCureProbDenom, autoCureProbNum :: Int
autoCureProbDenom = 3
autoCureProbNum = 2
